package yrpg.bamp.basedata.plugin.other.task;

import kd.bos.context.RequestContext;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.exception.KDException;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.schedule.executor.AbstractTask;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.sdk.plugin.Plugin;
import yrpg.bamp.basedata.plugin.util.OtherSysDBConnUtil;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Map;

/**
 * 后台任务插件
 */
public class GetCMSDevJobTask extends AbstractTask implements Plugin {

    @Override
    public void execute(RequestContext requestContext, Map<String, Object> map) throws KDException {

        String host=System.getProperty("yrpg.fi.cmshost");
        String port=System.getProperty("yrpg.fi.cmsport");
        String servicename=System.getProperty("yrpg.fi.cmsservicename");

        String url="jdbc:oracle:thin:@"+host+":"+port+"/"+servicename;
        String user=System.getProperty("yrpg.fi.cmsuser");
        String password=System.getProperty("yrpg.fi.cmspassword");

        SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
        //设置当前时间为0时区时间
        Date date=new Date();
        Calendar calendar=Calendar.getInstance();
        calendar.setTime(date);
        calendar.add(Calendar.HOUR_OF_DAY, -8);
        calendar.add(Calendar.DAY_OF_MONTH,-1);
        Date yesterday=calendar.getTime();

        long createorgid=100000L;//创建组织
        DynamicObject createorg=BusinessDataServiceHelper.loadSingle(createorgid,"bos_org");

        //研发项目
        QFilter numberfi= new QFilter("number", QCP.equals,"YFRW");
        QFilter[] filters = new QFilter[]{numberfi};
        DynamicObject group=BusinessDataServiceHelper.loadSingle("bos_assistantdatagroup","id,name,number",filters);

        String ctrlstrategy="6";//控制策略
        String status="C";//数据状态 已审核
        String enable="1";//使用状态 可用

        int isfullget=Integer.valueOf(map.get("isfullget").toString());//是否全量  1 全量
        Date selectdate=null;
        if(map.get("selectdate").toString().length()!=0){
            selectdate=(Date) map.get("selectdate");  //查询日期
        }

        OtherSysDBConnUtil dbutil = new OtherSysDBConnUtil();
        Connection conn= dbutil.getOrclConnection(url,user,password);

        PreparedStatement headStmt = null;
        ResultSet headRs = null;

        String sql=null;
        if(isfullget==1){//全量更新
            sql="SELECT app1.ACTIVITY_NUMBER task_number,case when SUBSTR(app1.ACTIVITY_NUMBER,1,2)='T1' then 1 else 2 end as lev,app1.STATUS status,app2.ACTIVITY_NUMBER proj_number,app2.TEXT31 internal_order,app1.LAST_UPD last_update FROM agile.ACTIVITY_P2P3 app1,agile.ACTIVITY_P2P3 app2 WHERE app1.ROOT_ID = app2.ID AND app1.DELETE_FLAG = 0 AND app1.SUBCLASS IN (2471902,2471956,2475166) order by app1.ACTIVITY_NUMBER";
        }else{
            if(selectdate!=null){//指定日期更新
                sql="SELECT app1.ACTIVITY_NUMBER task_number,case when SUBSTR(app1.ACTIVITY_NUMBER,1,2)='T1' then 1 else 2 end as lev,app1.STATUS status,app2.ACTIVITY_NUMBER proj_number,app2.TEXT31 internal_order,app1.LAST_UPD last_update FROM agile.ACTIVITY_P2P3 app1,agile.ACTIVITY_P2P3 app2 WHERE app1.ROOT_ID = app2.ID AND app1.DELETE_FLAG = 0 AND app1.SUBCLASS IN (2471902,2471956,2475166) AND TO_DATE(TO_CHAR(app1.LAST_UPD,'yyyy-MM-dd'),'yyyy-MM-dd')=to_date('"+sdf.format(selectdate)+"','yyyy-MM-dd')  order by app1.ACTIVITY_NUMBER";
            }else{//正常更新(前一天到当前时间)
                sql="SELECT app1.ACTIVITY_NUMBER task_number,case when SUBSTR(app1.ACTIVITY_NUMBER,1,2)='T1' then 1 else 2 end as lev,app1.STATUS status,app2.ACTIVITY_NUMBER proj_number,app2.TEXT31 internal_order,app1.LAST_UPD last_update FROM agile.ACTIVITY_P2P3 app1,agile.ACTIVITY_P2P3 app2 WHERE app1.ROOT_ID = app2.ID AND app1.DELETE_FLAG = 0 AND app1.SUBCLASS IN (2471902,2471956,2475166) AND app1.LAST_UPD>=to_date('"+sdf.format(yesterday)+"','yyyy-MM-dd')  order by app1.ACTIVITY_NUMBER";
            }
        }

        try {
            headStmt = conn.prepareStatement(sql, ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_READ_ONLY);
            //返回执行结果
            headRs = headStmt.executeQuery();
            while(headRs.next()){
                String number = headRs.getString("task_number");  //任务编码
                String name = headRs.getString("task_number");  //任务名称
                String proortaskstatus = headRs.getString("status"); //项目/任务状态
                String internalorder = headRs.getString("internal_order");  //内部订单号
                String projectnum = headRs.getString("proj_number");  //研发项目编码
                int lev=headRs.getInt("lev");  //级次
                numberfi= new QFilter("number", QCP.equals,number);
                filters = new QFilter[]{numberfi};
                DynamicObject ssistantdatadetail=BusinessDataServiceHelper.loadSingle("bos_assistantdata_detail","name,enable,modifytime",filters);

                if(ssistantdatadetail!=null){//已存在更新内容
                    ssistantdatadetail.set("name",name);
                    ssistantdatadetail.set("yrpg_proortaskstatus",proortaskstatus);
                    ssistantdatadetail.set("yrpg_internal_order",internalorder);
                    SaveServiceHelper.update(ssistantdatadetail);
                }else{//不存在新增
                    DynamicObject asddetailBillInfo = BusinessDataServiceHelper.newDynamicObject("bos_assistantdata_detail");
                    ORM.create().setPrimaryKey(asddetailBillInfo);
                    asddetailBillInfo.set("number",number);
                    asddetailBillInfo.set("name",name);
                    asddetailBillInfo.set("level",lev);
                    asddetailBillInfo.set("group",group);
                    asddetailBillInfo.set("createorg",createorg);
                    asddetailBillInfo.set("ctrlstrategy",ctrlstrategy);
                    asddetailBillInfo.set("status",status);
                    asddetailBillInfo.set("enable",enable);
                    asddetailBillInfo.set("yrpg_proortaskstatus",proortaskstatus);
                    asddetailBillInfo.set("yrpg_internal_order",internalorder);
                    asddetailBillInfo.set("yrpg_projectnum",projectnum);

                    OperateOption option = OperateOption.create();
                    OperationResult result = OperationServiceHelper.executeOperate("save", "bos_assistantdata_detail", new DynamicObject[]{asddetailBillInfo}, option);
                    boolean success = result.isSuccess();
                    /*if (!success) {
                        SaveIFSLogHelper.saveLog(fwtu_srckey,"recbill",result.getAllErrorOrValidateInfo().toString());
                    }*/

                }
            }
        } catch (SQLException e1) {
            throw new RuntimeException(e1);
        } finally {
            //释放资源
            if (headRs != null) {
                try {
                    headRs.close();
                } catch (SQLException e1) {
                }
            }

            if (headStmt != null) {
                try {
                    headStmt.close();
                } catch (SQLException e1) {
                }
            }
            if (conn != null) {
                try {
                    conn.close();
                } catch (SQLException e1) {
                }
            }
        }


    }
}